<?php
class Login extends Controller{
	function __construct(){
		parent::__construct();
	}
	function init(){
		echo "Login Api";
	}
	
	function businesslist($apikey){
		if(API_KEY===$apikey)
			$this->model->getbusinesslist();
		else
			echo json_encode(array("apiresult"=>"error"));
	}
	
	function userauth($apikey){
		if(API_KEY!==$apikey){
			echo json_encode(array('result'=>'Api Key Mismatch','bearertoken'=>'','role'=>''));
			exit;
		}		
		$data = json_decode(file_get_contents("php://input"));
		
		$token = time().rand(1000, 100000);
		$hashtoken = Hash::create('sha256',$token,HASH_KEY);
		$pass = Hash::create('sha256',$data->password,HASH_KEY);
		$userdt = $this->model->checkuser($data->email, $pass);
		
		$adddata = array(			
			"zemail"=>$data->email,
			"ztoken"=>$hashtoken,
			"zrole"=>'DEFAULT',
			"bizid"=>100,
			"zexpire"=>1
		);
		$this->model->updateprev($data->email);		
		
		//Logdebug::appendlog($userdt->useremail); die;
		if(count($userdt)>0){	
			$this->model->createuserlog($adddata);
			echo json_encode(array('result'=>'Success','bearertoken'=>$hashtoken,'role'=>'DEFAULT','username'=>$userdt[0]["user_name"]));
		}else{			
			echo json_encode(array('result'=>'Result Not Found','bearertoken'=>'','role'=>''));
		}
		
	}
	
	function updateprofilepass(){
		
		$data = json_decode(file_get_contents("php://input"));
		//Logdebug::appendlog(serialize($data->userEmail.$pass));
		$roledet = $this->model->getroledt($data->token);
		
		if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'Api Key Mismatch','response'=>'0','message'=>'Api Key Mismatch'));
			exit;
		}		
		if(count($roledet)===0){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Token Mismatch'));
			exit;
		}	
		
		$pass = Hash::create('sha256',$data->currentPassword,HASH_KEY);
		$newpass = Hash::create('sha256',$data->newPassword,HASH_KEY);
		
		$userdt = $this->model->checkuser($roledet[0]["zemail"], $pass);
		//
		if(count($userdt)===0){
			echo json_encode(array('result'=>'Old password did not match','response'=>'0','message'=>'Old password did not match'));
			exit;
		}
		
		/*$xdate = date("Y/m/d h:i:sa");
		$dt = str_replace('/', '-', $xdate);
		$date = date('Y-m-d h:i:sa', strtotime($dt));*/
		//Logdebug::appendlog("test");
		$adddata = array(			
			"login_pass"=>$newpass
		);
		
		$where = " login_name='".$roledet[0]["zemail"]."'";
		
		$result = $this->model->updateprofile($adddata, $where);	
		
		
		if($result>0){			
			echo json_encode(array('result'=>'Password Changed!','response'=>'0','message'=>'Password Changed!'));
		}else{			
			echo json_encode(array('result'=>'Error! Operation Failed!','response'=>'0','message'=>'Error! Operation Failed!'));
		}
		
	}
	
	function saveprofile(){
		$data = json_decode(file_get_contents("php://input"));
		$roledet = $this->model->getroledt($data->token);
		
		if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'Api Key Mismatch','respnse'=>''));
			exit;
		}		
		if(count($roledet)===0){
			echo json_encode(array('result'=>'Token Mismatch','response'=>''));
			exit;
		}	
		
		if($data->name===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Name not found'));
			exit;
		}
		if($data->user===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'User Name not found'));
			exit;
		}
		if($data->password===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Password not found'));
			exit;
		}
		if($data->email===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Email not found'));
			exit;
		}
		if($data->mobile===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Mobile not found'));
			exit;
		}
		
		
		$upuser = $this->model->getsingleuser($data->refid);
		
		if(count($upuser)==0){
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Ref. user not found!'));
			exit;
		}
		
		$bcno = $this->model->getbc($data->refid);
		
		//$point = $this->model->getpoint($roledet[0]['zemail']);
		
		$bc = $bcno[0]['maxbc']+1;
		
		$pass = Hash::create('sha256',$data->password,HASH_KEY);
		
				
		$xdate = date("Y/m/d h:i:sa");
		$dt = str_replace('/', '-', $xdate);
		$date = date('Y-m-d h:i:sa', strtotime($dt));
		$adddata = array(		
			"login_name"=>$data->user,
			"login_pass"=>$pass,
			"user_name"=>$data->name,
			"nid"=>$data->nid,
			"user_email"=>$data->email,			
			"user_cell_no"=>$data->mobile,
			"district"=>$data->district,
			"thana"=>$data->thana,
			"up_id"=>$upuser[0]["user_id"],
			"user_placement"=>$data->refid,
			"user_address"=>$data->address,
			"bc"=>$bc
		);
		

		$result = $this->model->createuser($adddata);		
		
		//Logdebug::appendlog($result); die;
		if($result>0){			
			echo json_encode(array('result'=>'no error!','response'=>$result,'message'=>$data->user.' signup done!'));
		}else{			
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Operation Failed!'));
		}
	}
	
	
	function postpoint(){
		$data = json_decode(file_get_contents("php://input"));
		$roledet = $this->model->getroledt($data->token);
		Logdebug::appendlog(serialize($data));
		if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'Api Key Mismatch','message'=>"API Key mismatch!"));
			exit;
		}		
		if(count($roledet)===0){
			echo json_encode(array('result'=>'Token Mismatch','message'=>"Token Mismatch"));
			exit;
		}

		$point = $this->model->getpoint($roledet[0]['zemail']);
		
		if($point<$data->point){
			echo json_encode(array('result'=>'error','response'=>'0','message'=>"Not enough point in point's pool!"));
		}
		$xdate = date("Y-m-d");
		$adddata = array(
			"xdate"=>$xdate,
			"bizid"=>'100',
			"stno"=>'1',
			"xrdin"=>$roledet[0]['zemail'],
			"zemail"=>$roledet[0]['zemail'],
			"xdoctype"=>"Point Posted",
			"xpoint"=>$data->point,
			"xsign"=>'-1',
			"xtype"=>"Point Posted"
		);
		
		$where = " login_name='".$roledet[0]['zemail']."'";
		$data = array("newpoint"=>"newpoint+".$data->point);
		
		$result = $this->model->updatepoint($adddata,$data,$where);
		
		
		
		if($result>0){			
			echo json_encode(array('result'=>'no error!','response'=>$result,'message'=>'Point posted!'));
		}else{			
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Operation Failed!'));
		}
	}
	
	function updateprofile(){
		$data = json_decode(file_get_contents("php://input"));
		//Logdebug::appendlog(serialize($data->userEmail.$pass));
		$roledet = $this->model->getroledt($data->token);
		
		if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'Api Key Mismatch','response'=>'0','message'=>'Api Key Mismatch'));
			exit;
		}		
		if(count($roledet)===0){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Token Mismatch'));
			exit;
		}	
		
				
			
		/*$xdate = date("Y/m/d h:i:sa");
		$dt = str_replace('/', '-', $xdate);
		$date = date('Y-m-d h:i:sa', strtotime($dt));*/
		//Logdebug::appendlog("test");
		$adddata = array(			
			"user_father"=>$data->fatherName,
			"user_mother"=>$data->motherName,
			"user_email"=>$data->email
		);
		
		$where = " login_name='".$roledet[0]["zemail"]."'";
		
		$result = $this->model->updateprofile($adddata, $where);	
		
		
		if($result>0){			
			echo json_encode(array('result'=>'Profile Updated!','response'=>'0','message'=>'Profile Updated!'));
		}else{			
			echo json_encode(array('result'=>'Error! Operation Failed!','response'=>'0','message'=>'Error! Operation Failed!'));
		}
	}
	
	function deleteprofile(){
		$data = json_decode(file_get_contents("php://input"));
		$roledet = $this->model->getroledt($data->token);
		
		if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'error','respnse'=>'0','message'=>'Api Key Mismatch'));
			exit;
		}		
		if(count($roledet)===0){
			echo json_encode(array('result'=>'error','response'=>'0', 'message'=>'Token Mismatch'));
			exit;
		}	
		
		if($data->xusersl===0 || $data->xusersl===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'User not found'));
			exit;
		}
		
		if($data->xusername===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'User not found'));
			exit;
		}
		if($data->xpassword===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Password not found'));
			exit;
		}
		if($data->xrole===""){
			echo json_encode(array('result'=>'Token Mismatch','response'=>'0','message'=>'Role not found'));
			exit;
		}
		
		$st = "delete from pausers where xusersl=".$data->xusersl;
		
		//Logdebug::appendlog($st);

		$result = $this->model->dbdelete($st);		
		
		//Logdebug::appendlog($result); die;
		if($result>0){			
			echo json_encode(array('result'=>'no error!','response'=>$result,'message'=>'User Deleted'));
		}else{			
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Operation Failed!'));
		}
	}
	
	public function authlogout($apikey)
	{	
		if(API_KEY!==$apikey){
			echo json_encode(array('result'=>'Api Key Mismatch','bearertoken'=>'','role'=>''));
			exit;
		}	
		$data = json_decode(file_get_contents("php://input"));		
		
		if($data->logout==="true"){			
				$this->model->updateprev($data->useremail);
				echo json_encode(array('result'=>'success'));
		}else{			
			echo json_encode(array('result'=>'error'));		
		}
	
}

function sendpasswordbymail(){	
	$data = json_decode(file_get_contents("php://input"));
	//Logdebug::appendlog(serialize($data)); die;
	if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'API Key mismatch!'));
			exit;
		}
		
	if($data->email==""){
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Email address not found!'));
			exit;
		}	
		
	$userdt = $this->model->checkuserforpass($data->email, $data->user);
	
	if(count($userdt)===0){
		echo json_encode(array('result'=>'error','response'=>'0','message'=>'User email not found!'));
		exit;
	}
		
	$mail = new Mailer();
	
	$rnum = time().rand(1000, 10000000);
	
	$pass = Hash::create('sha256',$rnum,HASH_KEY);
	$xdate = date("Y/m/d h:i:sa");
	$dt = str_replace('/', '-', $xdate);
	$date = date('Y-m-d h:i:sa', strtotime($dt));
	$adddata = array(			
			"login_pass"=>$pass
		);
		
		$where = " login_name='".$data->user."'";
		$result = $this->model->updateprofile($adddata, $where);
	
	$sub = "Annex Account. Password changed";
	
	$body = "Your new password is : ".$rnum.". Please change your password after login.";
		
	if($result>0){
		$mailresult = $mail->sendbyemail($data->email, $sub, $body, "");
		if($mailresult==="Success"){
			echo json_encode(array('result'=>'success','response'=>'0','message'=>'Password sent to your email!'));
		}else{
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Could not send password! Email not found!'));
		}
	}else{
		echo json_encode(array('result'=>'error','response'=>'0','message'=>'Could not create password!'));
	}
}

function sendpasswordbysms(){	
	$data = json_decode(file_get_contents("php://input"));
	//Logdebug::appendlog(serialize($data)); die;
	if(API_KEY!==$data->apikey){
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'API Key mismatch!'));
			exit;
		}
		
	if($data->mobile==""){
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Email address not found!'));
			exit;
		}		
		
	$userdt = $this->model->checkuserformobile($data->mobile, $data->user);
	
	if(count($userdt)===0){
		echo json_encode(array('result'=>'error','response'=>'0','message'=>'User email not found!'));
		exit;
	}
		
	$mail = new Mailer();
	
	$rnum = time().rand(1000, 10000000);
	
	$pass = Hash::create('sha256',$rnum,HASH_KEY);
	$xdate = date("Y/m/d h:i:sa");
	$dt = str_replace('/', '-', $xdate);
	$date = date('Y-m-d h:i:sa', strtotime($dt));
	$adddata = array(			
			"login_pass"=>$pass
		);
		
		$where = " login_name='".$data->user."'";
		$result = $this->model->updateprofile($adddata, $where);
	
	$sub = "Annex Account. Password changed";
	
	$body = "Your new password is : ".$rnum.". Please change your password after login.";
		
	if($result>0){
		$mailresult = $mail->sendbyemail($data->email, $sub, $body, "");
		if($mailresult==="Success"){
			echo json_encode(array('result'=>'success','response'=>'0','message'=>'Password sent to your email!'));
		}else{
			echo json_encode(array('result'=>'error','response'=>'0','message'=>'Could not send password! Email not found!'));
		}
	}else{
		echo json_encode(array('result'=>'error','response'=>'0','message'=>'Could not create password!'));
	}
}

	function getautolist($token, $searchstr=""){
		$roldet = $this->model->getroledt($token);
		if(count($roldet)===0){
			echo json_encode(array('result'=>'error','response'=>'Token Mismatch!','message'=>''));
			exit;
		}
				
		if($searchstr!=="")
			$this->model->getuserautolist($searchstr, $roldet[0]["bizid"]);
	}
	
	function getallautolist($token, $searchstr=""){
		$roldet = $this->model->getroledt($token);
		if(count($roldet)===0){
			echo json_encode(array('result'=>'error','response'=>'Token Mismatch!','message'=>''));
			exit;
		}
				
		if($searchstr!=="")
			$this->model->getuserallautolist($searchstr, $roldet[0]["bizid"]);
	}
	
	function rolelist($token){
		$roldet = $this->model->getroledt($token);
		if(count($roldet)===0){
			echo json_encode(array('result'=>'error','response'=>'Token Mismatch!','message'=>''));
			exit;
		}
		$this->model->getrolelist($roldet[0]["bizid"]);
	}
	
	function getuser($token){
		$roldet = $this->model->getroledt($token);
		if(count($roldet)===0){
			echo json_encode(array('result'=>'error','response'=>'Token Mismatch!','message'=>'Token Mismatch!'));
			exit;
		}
		$this->model->getuser($roldet[0]['zemail']);
	}
	function getbyuser($user,$token){
		$roldet = $this->model->getroledt($token);
		if(count($roldet)===0){
			echo json_encode(array('result'=>'error','response'=>'Token Mismatch!','message'=>'Token Mismatch!'));
			exit;
		}
		$this->model->getuser($user);
	}
	
	function getuserlist($token){
		$roldet = $this->model->getroledt($token);
		if(count($roldet)===0){
			echo json_encode(array('result'=>'error','response'=>'Token Mismatch!','message'=>''));
			exit;
		}
		$this->model->getuserlist($roldet[0]["bizid"]);
	}
}